#include "PointT.h"
#include "BankAccount.h"
#include "DataSetInterface.h"

#include <iostream>
using namespace std;

int main()
{

  //Test Data Set Inteface with PointT
  PointT p1(0.0, 0.0);
  PointT p2(3.0, 4.0);
  PointT p3(7.0, 24.0);
  PointT p4(5.0, 12.0);

  DataSetInterface ds;
  ds.add(&p1);
  ds.add(&p2);
  ds.add(&p3);
  ds.add(&p4);
  
  cout << "average = " << ds.getAverage() << "\n";

  Measurable *maxM = ds.getMaximum();

  PointT *maxP = (PointT*) maxM;

  cout << "maximum = " << *maxP << "\n";

  //Test Data Set Inteface with Bank Account

  BankAccount b1;
  b1.deposit(300);
  BankAccount b2;
  b2.deposit(100);

  DataSetInterface dsBank;
  dsBank.add(&b1);
  dsBank.add(&b2);
    
  cout << "average = " << dsBank.getAverage() << "\n";

  maxM = dsBank.getMaximum();

  BankAccount *maxB = (BankAccount*) maxM;

  cout << "maximum = " << *maxB << "\n";

  return 0;
}
