#ifndef POINTT_H
#define POINTT_H

#include "Measurable.h"

#include <iostream>

class PointT : public Measurable
{
  public:
    PointT(double x, double y);
    double xcoord();
    double ycoord();
    double distToOrigin();

    friend std::ostream& operator<< (std::ostream &out, const PointT &point);

    double getMeasure();
    
  private: 
    double xc;
    double yc;
};

#endif
